<div class="miam-list-input">
  <div class="miam-list-input__list" [formGroup]="list">
    <div class="miam-list-input__list__label">{{label}}</div>
    <ul *ngIf='list.controls?.length > 0 else hintPlaceholder' class="miam-list-input__container m-default-card" cdkDropList (cdkDropListDropped)="drop($event)">
      <ng-container *ngIf='!ingredientMode else ingredientRow'>
        <li *ngFor="let row of list.controls; let i = index; trackBy: trackByIndex"  cdkDrag>
          <ng-container [formGroup]="row">
            <ng-container [formGroup]="row?.get('attributes')">
              <div class="miam-list-input__container__row  m-default-card">
              <ng-miam-icon primaryColor="var(--m-color-grey05)" class="miam-list-input__row__grip"  [iconName]="icon.Grip" cdkDragHandle></ng-miam-icon>
              <textarea  cdkTextareaAutosize='true' #autosize="cdkTextareaAutosize" (blur)='checkRow(i)'
                cdkAutosizeMinRows="1" cdkAutosizeMaxRows="50" class="m-input" formControlName='description'></textarea>
              </div>
              <ng-miam-icon class="miam-list-input__row__trash" (click)="delete(i)" primaryColor="var(--m-color-grey05)" [iconName]="icon.Trash"></ng-miam-icon>
              <div class="miam-list-input__row__placeholder" *cdkDragPlaceholder></div>
              <div class="miam-list-input__row__preview m-default-card" *cdkDragPreview>
                <ng-miam-icon primaryColor="var(--m-color-grey05)" [iconName]="icon.Grip" cdkDragHandle></ng-miam-icon>
                <span class="miam-list-input__preview__text m-body-typo">{{row?.get('attributes')?.get('description').value}}</span>
              </div>
            </ng-container>
          </ng-container>
        </li>
      </ng-container>
      <ng-template #ingredientRow>
          <li *ngFor="let row of list.controls; let i = index; trackBy: trackByIndex" cdkDrag>
            <div class="miam-list-input__container__row m-default-card" [formGroupName]="i">
              <div class="miam-list-input__row__left">
                <ng-miam-icon primaryColor="var(--m-color-grey05)" class="miam-list-input__row__grip"
                [iconName]="icon.Grip" cdkDragHandle></ng-miam-icon>
                <input class="m-input" [ngModel]="row['controls']['attributes']['controls']['name'].value | capitalizeFirstLetter"
                  [formControl]="row['controls']['attributes']['controls']['name']"/>
              </div>
              <div class="miam-list-input__row__right">
                <input class="m-input" [ngModel]="row['controls']['attributes']['controls']['quantity'].value" (ngModelChange)="updateQuantityValue($event, i)"
                  [formControl]="row['controls']['attributes']['controls']['quantity']" maxSize=4  autoWidthInput />
                <input class="m-input"  [formControl]="row['controls']['attributes']['controls']['unit']"  maxSize=8 autoWidthInput/>
              </div>
            </div>
            <ng-miam-icon class="miam-list-input__row__trash" (click)="delete(i)" primaryColor="var(--m-color-grey05)" [iconName]="icon.Trash"></ng-miam-icon>
              <div class="miam-list-input__row__placeholder" *cdkDragPlaceholder></div>
              <div class="miam-list-input__row__preview m-default-card" *cdkDragPreview>
                <ng-miam-icon primaryColor="var(--m-color-grey-text-dark)" 
                  [iconName]="icon.Grip" cdkDragHandle></ng-miam-icon>
                <span class="m-body-typo">{{row?.get('attributes')?.get('name').value | capitalizeFirstLetter}}</span>
                <span class="m-body-typo">{{row?.get('attributes')?.get('quantity').value}}</span>
                <span class="m-body-typo">{{row?.get('attributes')?.get('unit').value}}</span>
            </div>
            <!-- information message -->
            <!-- <span *ngIf="row?.get('attributes')['isNotReviewedIngredientName'] && !row.invalid && !hideErrors"
              class="hint warnning">Nous ne connaissons pas encore cet ingrédient</span>
            <span *ngIf="row.invalid && !hideErrors" class="hint error">Le nom de l'ingrédient ne peut pas être
              vide</span> -->
          </li>
      </ng-template>
    </ul>
  </div>
  <ng-template #hintPlaceholder>
    <div class="miam-list-input__placeholder miam-list-input__container m-default-card">
      <ng-miam-icon primaryColor="var(--m-color-grey-text-dark)" [width]="152" [height]="157" [iconName]="icon.Empty">
      </ng-miam-icon>
      <span class="miam-list-input__placeholder__hint m-body-typo">Oups... c’est vide, commencez à ajouter des {{ hint }} !</span>
    </div>
  </ng-template>
  <div class="miam-list-input__actions">
    <textarea matInput class="m-input" cdkTextareaAutosize  cdkAutosizeMinRows="4"
      cdkAutosizeMaxRows="4" (keydown.enter)='mousseDownOnButton = true' 
      [formControl]="fillListInput" attr.placeholder="{{placeholder}}"></textarea>
      <div *ngIf="instructions" class="miam-list-input__actions__instructions">{{instructions}}</div>
    <button class="m-button-primary" (mousedown)='mousseDownOnButton = true' (mouseup)="submit()">
      Ajouter >>
    </button>
  </div>
</div>